config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :quizzes
  resources :questions
  resources :quiz_sessions do
    resources :steps, controller: 'quiz_sessions/steps'
  end
  resources :users

  get "up" => "rails/health#show", as: :rails_health_check

  root "quizzes#index"
end

app/models/question.rb
class Question < ApplicationRecord
  include AttrJson::Record

  has_many :question_quizzes
  has_many :quizzes, through: :question_quizzes

  attr_json_config(default_container_attribute: :config)

  attr_json :type, :string
  attr_json :alternatives, Question::Alternatives.to_type, default: [], array: true
  attr_json :correct_alternative, :string
end

app/models/question/alternatives.rb
class Question::Alternatives
  include AttrJson::Model

  attr_json :type, :string
  attr_json :identifier, :string
  attr_json :text, :string
  attr_json :image_url, :string, default: ''
  attr_json :bg_color, :string, default: '#808080'
  attr_json :text_color, :string, default: '#000000'
end

app/controllers/questions_controller.rb
class QuestionsController < ApplicationController
  before_action :set_question, only: %i[ show edit update destroy ]

  # GET /questions or /questions.json
  def index
    @questions = Question.all
  end

  # GET /questions/1 or /questions/1.json
  def show
  end

  # GET /questions/new
  def new
    @question = Question.new
  end

  # GET /questions/1/edit
  def edit
  end

  # POST /questions or /questions.json
  def create
    @question = Question.new(question_params)

    respond_to do |format|
      if @question.save
        format.html { redirect_to question_url(@question), notice: "Question was successfully created." }
        format.json { render :show, status: :created, location: @question }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /questions/1 or /questions/1.json
  def update
    respond_to do |format|
      if @question.update(question_params)
        format.html { redirect_to question_url(@question), notice: "Question was successfully updated." }
        format.json { render :show, status: :ok, location: @question }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /questions/1 or /questions/1.json
  def destroy
    @question.destroy!

    respond_to do |format|
      format.html { redirect_to questions_url, notice: "Question was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_question
      @question = Question.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def question_params
      params.require(:question).permit(:identifier, :statement, :description, :config)
    end
end

app/helpers/questions_helper.rb
module QuestionsHelper
end

app/views/questions/_form.html.erb
<%= form_with(model: question) do |form| %>
  <% if question.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(question.errors.count, "error") %> prohibited this question from being saved:</h2>

      <ul>
        <% question.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :identifier, style: "display: block" %>
    <%= form.text_field :identifier %>
  </div>

  <div>
    <%= form.label :statement, style: "display: block" %>
    <%= form.text_field :statement %>
  </div>

  <div>
    <%= form.label :description, style: "display: block" %>
    <%= form.text_field :description %>
  </div>

  <div>
    <%= form.label :config, style: "display: block" %>
    <%= form.text_field :config %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/questions/_question.html.erb
<div id="<%= dom_id question %>">
  <p>
    <strong>Identifier:</strong>
    <%= question.identifier %>
  </p>

  <p>
    <strong>Statement:</strong>
    <%= question.statement %>
  </p>

  <p>
    <strong>Description:</strong>
    <%= question.description %>
  </p>

  <p>
    <strong>Config:</strong>
    <%= question.config %>
  </p>

</div>

app/views/questions/edit.html.erb
<h1>Editing question</h1>

<%= render "form", question: @question %>

<br>

<div>
  <%= link_to "Show this question", @question %> |
  <%= link_to "Back to questions", questions_path %>
</div>

app/views/questions/index.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<h1>Questions</h1>

<div id="questions">
  <% @questions.each do |question| %>
    <%= render question %>
    <p>
      <%= link_to "Show this question", question %>
    </p>
  <% end %>
</div>

<%= link_to "New question", new_question_path %>

app/views/questions/new.html.erb
<h1>New question</h1>

<%= render "form", question: @question %>

<br>

<div>
  <%= link_to "Back to questions", questions_path %>
</div>

app/views/questions/show.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<%= render @question %>

<div>
  <%= link_to "Edit this question", edit_question_path(@question) %> |
  <%= link_to "Back to questions", questions_path %>

  <%= button_to "Destroy this question", @question, method: :delete %>
</div>